SystemOrganization addCategory: #'Pier-SlideShare'!

PRExternalLink subclass: #PRSlideShareLink
	instanceVariableNames: 'data'
	classVariableNames: 'ApiKey SharedSecret'
	poolDictionaries: ''
	category: 'Pier-SlideShare'!

!PRSlideShareLink class methodsFor: 'initialization' stamp: 'lr 9/8/2008 21:44'!
initialize
	ApiKey := MACompatibility
		request: 'SlideShare API Key:'
		default: '(get from http://www.slideshare.net/developers/applyforapi)'.
	SharedSecret := MACompatibility
		request: 'SlideShare Shared Secret:'
		default: ''! !

!PRSlideShareLink class methodsFor: 'testing' stamp: 'lr 9/8/2008 16:56'!
isValidReference: aString
	^ aString beginsWith: 'slideshare:'! !

!PRSlideShareLink class methodsFor: 'accessing' stamp: 'lr 9/8/2008 16:55'!
priority
	^ 20! !

!PRSlideShareLink methodsFor: 'visiting' stamp: 'lr 9/8/2008 21:31'!
accept: aVisitor
	aVisitor visitSlideSlideLink: self! !

!PRSlideShareLink methodsFor: 'private' stamp: 'lr 9/8/2008 21:44'!
fetch: aString
	| ts hash url response result |
	ts := Time totalSeconds asString.
	hash := ((SecureHashAlgorithm new
		hashMessage: SharedSecret , ts)
		printStringBase: 16)
		asLowercase.
	url := 'http://www.slideshare.net/api/1/get_slideshow_info?api_key=' , 
		ApiKey , '&ts=' , ts , '&hash=' , hash , '&slideshow_id=' , aString.
	response := HTTPSocket httpGet: url.
	result := Dictionary new.
	result isString ifFalse: [
		(XMLDOMParser parseDocumentFrom: response)
			tagsNamed: #Slideshow do: [ :element |
				element elementsDo: [ :each |
					result at: each localName put: each contentString ] ] ].
	^ result! !

!PRSlideShareLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 21:56'!
height
	^ self parameterAt: 'height' ifAbsent: [ (self width / 1.1972) rounded ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:38'!
id
	^ data at: #PlayerDoc ifAbsent: [ String new ]! !

!PRSlideShareLink methodsFor: 'testing' stamp: 'lr 9/8/2008 21:28'!
isBroken
	^ data isEmpty! !

!PRSlideShareLink methodsFor: 'accessing' stamp: 'lr 9/8/2008 21:45'!
reference: aString
	super reference: aString.
	data := self fetch: self urlEntry! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:26'!
title
	^ data at: #Title ifAbsent: [ super title ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:29'!
url
	^ data at: #URL ifAbsent: [ super url ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 16:55'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:30'!
urlPrefix
	^ '#'! !

!PRSlideShareLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 17:06'!
width
	^ self parameterAt: 'width' ifAbsent: [ 425 ]! !

!PRViewRenderer methodsFor: '*pier-slideshare' stamp: 'lr 9/8/2008 21:53'!
visitSlideSlideLink: anObject
	(anObject isBroken not and: [ anObject isEmbedded ])
		ifTrue: [ html html: '<object style="margin: 0px" width="' , anObject width asString , '" height="' , anObject height asString , '"><param name="movie" value="http://static.slideshare.net/swf/ssplayer2.swf?doc=' , anObject id , '&rel=0"/><param name="allowFullScreen" value="true"/><param name="allowScriptAccess" value="always"/><embed src="http://static.slideshare.net/swf/ssplayer2.swf?doc=' , anObject id , '&rel=0" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="' , anObject width asString , '" height="' , anObject height asString , '"></embed></object>' ]
		ifFalse: [
			html anchor
				class: 'external';
				url: anObject url;
				class: 'broken' if: anObject isBroken;
				with: [ self visitLink: anObject ] ]! !

!PRVisitor methodsFor: '*pier-slideshare' stamp: 'lr 9/8/2008 21:31'!
visitSlideSlideLink: anObject
	self visitExternalLink: anObject! !
PRSlideShareLink initialize!
